O = [0 1; 1 3; 2 3; 3 7];
% observations of some 1D function
% O(:,1) are the arguments, a
% O(:,2) are the desired fit values, b
 
% we are trying to estimate b = p + qa + ra^2
% where x = [p q r] is our unknown
 
m = length(O);
A = [ones(m, 1), O(:, 1), O(:, 1).^2];
% stack the equations (1p + aq + a^2r)
 
%x = (A' * A) \ A' * O(:,2)
% solve normal equation (backslash = solve)

[U,S,V] = svd(A); % take SVD of A
Splus = zeros(size(S')); % S' may be rectangular
n = size(A, 2); % length of the diagonal
Splus(1:n, 1:n) = diag(1 ./ diag(S))' % recip. diag.
x = V * Splus * U' * O(:,2)
% solve using SVD
 
xx = linspace(min(O(:, 1)) - .5, max(O(:, 1)) + .5);
yy = x(1) + x(2) * xx + x(3) * (xx.^2);
% evaluate the estimated model
 
plot(O(:, 1), O(:, 2), '*k') % plot a-s, b-s
hold on
plot(xx, yy, '-r') % plot the fitted curve
hold off

ylim([0 10])
% keep the plot together
