O = [0 1; 1 3; 2 3; 3 7];
% observations of some 1D function
% O(:,1) are the arguments, a
% O(:,2) are the desired fit values, b

plot(O(:, 1), O(:, 2), '*k') % plot a-s, b-s
hold on

x = [1 -1 -.1]';
% guess 0x (deliberately a bad guess, to take a few steps)

xx = linspace(min(O(:, 1)) - .5, max(O(:, 1)) + .5);
for i = 1:10
    yy = x(1) + x(1) * x(2) * xx + x(1) * x(2) * x(3) * (xx.^2);
    plot(xx, yy, '-b') % plot the initial guess
    % evaluate the initial guess

    % we are trying to estimate b = p + pqa + pqra^2
    % where x = [p q r] is our unknown
    % h(x) = p + pqa + pqra^2, J = dh / dx = [1+qa+qra^2 pa+pra^2 qa^2]

    J = [1 + x(2) * O(:, 1) + x(2) * x(3) * O(:, 1).^2, ...
        x(1) * O(:, 1) + x(1) * x(3) * O(:, 1).^2, x(1) * x(2) * O(:, 1).^2];
    % calculate the Jacobian

    db = O(:,2) - x(1) - O(:, 1) * x(1) * x(2) - O(:, 1).^2 * x(1) * x(2) * x(3);
    % calculate current error vector

    dx = (J' * J) \ J' * db; norm_dx = norm(dx)
    % solve normal equation (backslash = solve)
    
    if(norm_dx < 1e-6)
        break
    end
    % see if we optimized

    x = x + dx
    % increment
end

yy = x(1) + x(1) * x(2) * xx + x(1) * x(2) * x(3) * (xx.^2);
plot(xx, yy, '-r') % plot the fitted curve
hold off
% evaluate the estimated model

ylim([0 10])
% keep the plot together
